Attribute VB_Name = "mdMMVariables"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Form:    mdMMVariables.frm                                   *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************

Option Explicit
Public Declare Function synchronization Lib "winmainclientdll.dll" ( _
            ByVal isSlow As String, ByVal xmlAll As String, _
            ByVal xmlNew As String, ByVal xmlMod As String, ByVal xmlDel As String, _
            ByVal folderType As String, ByVal path As String) As String
Public Declare Function endSynchronization Lib "winmainclientdll.dll" (ByVal xmlMapping As String, ByVal folderType As String) As Integer
Public Declare Function startSynchronization Lib "winmainclientdll.dll" ( _
            ByVal isSlow As String, ByVal folderType As String, ByVal path As String) As String
Public Declare Function printLog Lib "winmainclientdll.dll" (ByVal log As String, ByVal level As String) As Integer
Public Declare Function openLog Lib "winmainclientdll.dll" (ByVal path As String) As Integer
Public Declare Function closeLog Lib "winmainclientdll.dll" () As Integer
'Public Declare Function endSynchronization Lib "winmainclientdll.dll" (ByVal xmlMapping As String) As Integer

Public Declare Function freeMemAlloc Lib "winmainclientdll.dll" () As Integer
'write in outlook key in registry configuration
Public Declare Function saveOutlookConfig Lib "winmainclientdll.dll" (ByVal propertyName As String, ByVal propertyValue As String) As Long
'read parameter configuration from syncml key in registry configuration
Public Declare Function getServerConfigParameter Lib "winmainclientdll.dll" (ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setServerConfigParameters Lib "winmainclientdll.dll" ( _
        ByVal syncURL As String, ByVal serverName As String, ByVal username As String, _
        ByVal password As String, ByVal deviceId As String) As Long

Public Declare Function getSourceSync Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setSourceSync Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String) As Long
Public Declare Function getDayLight Lib "winmainclientdll.dll" () As Long
Public Declare Function getClientConfiguration Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setClientConfiguration Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String) As Long
Public Declare Function isAnotherWindow Lib "winmainclientdll.dll" () As Long
'for scheduler
Public Declare Function createTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String, _
                         ByVal AccountName As String, _
                         ByVal AccountPassword As String) As Long
Public Declare Function updateTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String, _
                         ByVal AccountName As String, _
                         ByVal AccountPassword As String) As Long
Public Declare Function getTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String, _
                         ByVal AccountName As String, _
                         ByVal AccountPassword As String, _
                         ByVal Status As String, _
                         ByVal propSize As Long) As Long
Public Declare Function deleteTask Lib "winmainclientdll.dll" () As Long


'xp style
Public Declare Sub InitCommonControls Lib "comctl32.dll" ()


Public dayLight As Long
Public isOutlookInitialized As Boolean

Public containsNewItems As Integer
'Public newItems() As String --> not used this. Please see to mdVariables.createdList

Public modItems() As String
Public containsModItems As Integer

Public delItems() As String
Public containsDelItems As Integer

Public droppedItems As Integer

Public tempReturnedMessage As String
Public Const SYNC_CONTACTS As String = "sync.contacts"
Public Const SYNC_APPOINTMENTS As String = "sync.appointments"
Public Const SYNC_TASKS As String = "sync.tasks"
Public Const SYNC_NOTES As String = "sync.notes"

Public Const TAG_START_CONTACTS As String = "<contacts>"
Public Const TAG_END_CONTACTS As String = "</contacts>"
Public Const TAG_START_CONTACT As String = "<contact>"
Public Const TAG_END_CONTACT As String = "</contact>"

Public Const TAG_START_TASKS As String = "<tasks>"
Public Const TAG_END_TASKS As String = "</tasks>"
Public Const TAG_START_TASK As String = "<task>"
Public Const TAG_END_TASK As String = "</task>"

Public Const TAG_START_NOTES As String = "<notes>"
Public Const TAG_END_NOTES As String = "</notes>"
Public Const TAG_START_NOTE As String = "<note>"
Public Const TAG_END_NOTE As String = "</note>"

Public Const TAG_START_CALENDARS As String = "<calendars>"
Public Const TAG_END_CALENDARS As String = "</calendars>"
'Public Const TAG_START_CALENDAR As String = "<calendar>"
'Public Const TAG_END_CALENDAR As String = "</calendar>"
'Public Const ROOT_NAME = "calendar"
'IMPORTANT: modify ROOT_NAME variable too...

Public Const ROOT_CAL_NAME = "appointment"
Public Const TAG_START_CALENDAR As String = "<appointment>"
Public Const TAG_END_CALENDAR As String = "</appointment>"


Public Const SPDM_USERNAME = "spdm.username"
Public Const SPDM_PASSWORD = "spdm.password"
Public Const SPDM_SERVERNAME = "spdm.serverName"
Public Const SPDM_SYNCURL = "spdm.syncURL"
Public Const SPDM_DEVICEID = "spdm.deviceId"
Public Const NONE = "none"
Public Const TWO_WAY = "two-way"
Public Const SYNCCONTACTS = "sync.contacts"
Public Const SYNCAPPOINTMENTS = "sync.appointments"
Public Const SYNCTASKS = "sync.tasks"
Public Const SYNCNOTES = "sync.notes"

'extra propertis
Public Const PROPERTY_SOURCE_SHOW = "spdm.show"
Public Const PROPERTY_REMOTE = "spdm.showRemoteSettings"
Public Const PROPERTY_SYSTEMTIME_TO_LOCALTIME = "spdm.adjustSystemTimeToLocalTime"

Public Const PROPERTY_SOURCE_SYNC = "sync"
Public Const PROPERTY_SOURCE_REMOTEURI = "uri"
Public Const DIM_VALUE = 128

Public Const CONF_SAVE_SUCCESFULLY = "Configuration saved successfully"
Public Const CONF_NOT_SAVE_SUCCESFULLY = "Configuration not saved."

Public Const WAITLABEL_CAPTION_W = "Please wait: synchronization in progress..."
Public Const WAITLABEL_CAPTION_END = "Synchronization successfully completed!"
Public Const WAITLABEL_CAPTION_DROPPED = "Sync completed. Some items dropped. See log."
Public Const LOGO_BMP = "logo.bmp"
Public Const ARROWS_BMP = "arrows_sync.bmp"
Public Const ARROWSWAIT_BMP = "arrows_pleasewait.bmp"
Public Const DIR_IMAGES = "images"
Public Const ICO = "fsc.ico"
Public Const WAITLABEL_CAPTION_ERR_ENDING_SYNC = "Error in completing sync..."
Public Const SYNC_CLIENT_OUTLOOK = "SyncClient Outlook"
Public Const EXIT_BUTTON = "Synchronize"
Public Const EXIT_BUTTON_WAIT = "Please wait..."
Public Const WAITLABEL_NO_SOURCE_TO_SYNC = "Nothing to sync. Please check Sync Settings..."

'FormAbout

Public Const ABOUT_PRODUCT_NAME = "Sync4j SyncClient Outlook v. "
Public Const ABOUT_FUNAMBOL = "www.sync4j.org"
Public Const ABOUT_COPYRIGHT = "Copyright (c) 2003 - 2005 Funambol."
Public Const ABOUT_RESERVED = "All rights reserved."


'Returned Error Messages. Same codes like in scapi's Constants.h
Public Const ERR_TPCIP_INIT = 2000
Public Const ERR_CONNECT = 2001
Public Const ERR_READING_CONTENT = 2002
Public Const ERR_HTTP = 2003
Public Const ERR_HTTP_MISSING_CONTENT_LENGTH = 2004
Public Const ERR_RESP_URI_DIFFERS_FROM_URL = 2008

Public Const ERR_PROTOCOL_ERROR = 400
Public Const ERR_AUTH_NOT_AUTHORIZED = 401
Public Const ERR_AUTH_EXPIRED = 402
Public Const ERR_NOT_FOUND = 404
Public Const ERR_AUTH_REQUIRED = 407
Public Const ERR_SRV_FAULT = 500

Public Const MSG_ERR_CONNECT = "Error connecting to the server."
Public Const MSG_ERR_PROTOCOL_ERROR = "Protocol Error. Check server URL"
Public Const MSG_ERR_READING_CONTENT = "Error reading content. Server unavailable"
Public Const MSG_ERR_AUTH_REQUIRED = "Not authorized. Check Communication Settings - Username or Password property."
Public Const MSG_ERR_AUTH_EXPIRED = "Account expired."
Public Const MSG_ERR_SRV_FAULT = "Server error"
Public Const MSG_ERR_NOT_FOUND = "Server returned source NOT FOUND. Check Synchronization Settings - Remote Name property."
Public Const MSG_ERR_GENERIC = "Synchronization NOT completed."
Public Const MSG_ERR_RESP_URI_DIFFERS_FROM_URL = "Error reconnecting to the server. "

Public Const DEBUG_LEVEL = "DEBUG"
Public Const INFO_LEVEL = "INFO"
Public Const ERROR_LEVEL = "ERROR"

'FormScheduler
Public Const NEVER = "Never"
Public Const EVERY_DAY = "Every day"
Public Const NO_TASK = "No task"
Public Const CUSTOM_TASK = "Custom task"
Public Const NO_TASK_SCHEDULED = "No task scheduled"
Public Const EXTERNAL_CUSTOMIZE_TASK = "Not supported schedule. Default settings will be restored"
Public Const TASK_DISABLED = "Task disabled"
Public Const ACCOUNT_PASSWORD_REQUIRED = "Account password is required"
Public Const ACCOUNT_NAME_REQUIRED = "Account name is required"
Public Const EVERY_MINUTES = "Please set a value < of 1440 (24h)"
Public Const EVERY_DAYS = "Please set a value"

Public Function getVersion() As String
'Calculate the complete path of the application
    
    
    Dim sVersion As String
    sVersion = App.Major & "." & App.Minor & "." & App.Revision
    getVersion = sVersion
End Function

Public Function replaceMinorAndMajorAndAmp(ByVal element As String)
    
    
    If element <> Empty And element <> "" Then
        If InStr(element, "<") <> 0 Or InStr(element, ">") <> 0 Or InStr(element, "&") <> 0 Then
            Dim ret As String
            ret = ReplaceAll(element, "&", "&amp;")
            ret = ReplaceAll(ret, "<", "&lt;")
            ret = ReplaceAll(ret, ">", "&gt;")
            replaceMinorAndMajorAndAmp = ret
        Else
            replaceMinorAndMajorAndAmp = element
        End If
    Else
        replaceMinorAndMajorAndAmp = element
    End If
    

End Function

Public Function replaceMinorAndMajorAndAmpFromServer(ByVal element As String)
    
    
    If element <> Empty And element <> "" Then
        If InStr(element, "<") <> 0 Or InStr(element, ">") <> 0 Or InStr(element, "&") <> 0 Then
            Dim ret As String
            ret = ReplaceAll(element, "&amp;", "&")
            ret = ReplaceAll(ret, "&lt;", "<")
            ret = ReplaceAll(ret, "&gt;", ">")
            replaceMinorAndMajorAndAmpFromServer = ret
        Else
            replaceMinorAndMajorAndAmpFromServer = element
        End If
    Else
        replaceMinorAndMajorAndAmpFromServer = element
    End If
    

End Function



Public Function AppPath() As String
'Calculate the complete path of the application
    
    
    Dim path
    path = App.path
    If path = "\" Then
        AppPath = "\"
    Else
        AppPath = path & "\"
    End If
    
End Function


Public Function isPropertyInRecurrenceObject(ByVal element As String)
 If element = "RecurrenceType" _
        Or element = "Interval" _
        Or element = "MonthOfYear" _
        Or element = "DayOfMonth" _
        Or element = "DayOfWeekMask" _
        Or element = "Instance" _
        Or element = "PatternStartDate" _
        Or element = "PatternEndDate" _
        Or element = "NoEndDate" Then
        isPropertyInRecurrenceObject = True
    Else
        isPropertyInRecurrenceObject = False
    End If
    
        
End Function

Public Function isValidProperty(ByVal name As String, ByVal valueOfRecurrenceType)
    Dim ret As Boolean
    
    
    
    If name = "RecurrenceType" Then
        ret = True
    ElseIf valueOfRecurrenceType = 0 And name = "Interval" Then
        ret = True
    Else
        ret = False
        isValidProperty = ret
    End If
    'ElseIf valueOfRecurrenceType = 1 And ( _
    '   name = "Interval" Or _
    '   name = "DayOfWeekMask" Then
    '
    '   ret = True
    'ElseIf valueOfRecurrenceType = 2 And ( _
    '   name = "Interval" Or _
    '   name = "DayOfWeekMask" Then


End Function


Function getStringAllItemsInFolder(ByRef objFolder As Outlook.MAPIFolder, ByRef folderType As Integer)
    'prepare the file NAME_ALL_FILE, listing all the items in the olFolder objFolder

Dim objItems As Outlook.Items
Dim objItemRecurrence As Object
Dim countItems As Long
Dim writingLine As String

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Tasks"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Tasks"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
       
Case mdVariables.FOLDER_TYPE_MAIL
    'writingLine = "Mail"
End Select

Dim intNumItems As Integer
intNumItems = objFolder.Items.Count
Dim numItems As String
numItems = "" & intNumItems


Dim ret As String

    ret = START_ROOT
    ret = ret + "<numItems>" + numItems + "</numItems>"
        
     
    'handle each item
    For countItems = 1 To objFolder.Items.Count
        'error control first
        On Error Resume Next
        Err.Clear
        Set objItems = objFolder.Items
        If 0 <> Err.Number Then
            logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
        ElseIf objItems Is Nothing Then
            MsgBox "The folder " & objFolder.name & " is empty"
        Else 'all is ok
            If folderType = FOLDER_TYPE_CAL Then
                Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
            End If
            
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    props(K, 1) = mdActions.getItemPropertyValue( _
                        objItems.Item(countItems), mdVariables.contactsProperties(K).Property)
                
                ElseIf folderType = FOLDER_TYPE_CAL Then
                    props(K, 0) = mdVariables.calendarProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                        props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            mdVariables.calendarProperties(K).Property)
                    Else
                        props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                            mdVariables.calendarProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_TASK Then
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                    
                        props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                            mdVariables.tasksProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    props(K, 0) = mdVariables.notesProperties(K).Property
                    props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                        mdVariables.notesProperties(K).Property)
                                        
                End If
                
            Next K
            
            ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
            ' IsRecurring property to True also if it isn't!!
            If folderType = FOLDER_TYPE_TASK Then
                Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
                For K = 1 To UBound(props)
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                        props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            mdVariables.tasksProperties(K).Property)
                    End If
                Next K
            End If
            
            ret = ret + "<row>"
            ret = ret + "<identifier>" + objItems.Item(countItems).EntryID + "</identifier>"
            ret = ret + "<bodyMsgValue>"
            ret = ret + INTERNAL_START_ROOT
            
            For K = 1 To UBound(props)
                ret = ret + "<" + CStr(props(K, 0)) + ">"
                'ret = ret + CStr(props(K, 1))
                ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                ret = ret + "</" + CStr(props(K, 0)) + ">"

            Next K
                      
            ret = ret + INTERNAL_END_ROOT
            ret = ret + "</bodyMsgValue>"
            ret = ret + "</row>"
    
        End If
    Next
    
    ret = ret + END_ROOT
    logToDebug ret

getStringAllItemsInFolder = ret

End Function

Function getStringNewItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
Dim objItem As Object
Dim objItemRecurrence As Object
Dim I As Integer

Dim ret As String
ret = ""
Dim numItems As Integer
numItems = -1
    
Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String
       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Notes"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    
End Select
    
On Error GoTo getStringErrorManager
      
                
        numItems = UBound(mdVariables.createdList)
        If numItems <> -1 And mdVariables.createdList(0) <> "-1" Then
        'If numItems <> -1 Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
                    
        
            For I = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdList(I))
                
                If folderType = FOLDER_TYPE_CAL Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                End If
               
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                    ElseIf folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.calendarProperties(K).Property)
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.tasksProperties(K).Property)
                        
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                    End If
                
                Next K
                  
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                  
                  
                ret = ret + "<row>"
                ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                ret = ret + "<bodyMsgValue>"
                ret = ret + INTERNAL_START_ROOT
                ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                
                ret = ret + INTERNAL_END_ROOT
                ret = ret + "</bodyMsgValue>"
                ret = ret + "</row>"
            Next
            ret = ret + END_ROOT
            
        End If
        logToDebug ret
    
    getStringNewItemsInFolder = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
      
    
End Function

Function getStringModItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
    Dim objItem As Object
    Dim objItemRecurrence As Object
       
    Dim I As Integer
    
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String
       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)

Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Note"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    
End Select
    
On Error GoTo getStringErrorManager
       
        numItems = UBound(mdMMVariables.modItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.modItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdMMVariables.modItems(I))
                If folderType = FOLDER_TYPE_CAL Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                End If
                'If folderType = FOLDER_TYPE_TASK Then
                '    Set objItemRecurrence = objItem.GetRecurrencePattern
                'End If
                
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                    ElseIf folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.calendarProperties(K).Property)
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.tasksProperties(K).Property)
                        
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                    End If
                
                Next K
                
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                
                ret = ret + "<row>"
                ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                ret = ret + "<bodyMsgValue>"
                ret = ret + INTERNAL_START_ROOT
               ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                ret = ret + INTERNAL_END_ROOT
                ret = ret + "</bodyMsgValue>"
                ret = ret + "</row>"
            Next
            ret = ret + END_ROOT
        End If
    
        logToDebug ret
            
getStringModItemsInFolder = ret
        
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
   
End Function

Function getStringDelItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
    'per i deleted mando solo gli id
    Dim objItem As Object
    Dim I As Integer
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String

       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "note"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES

End Select
       
On Error GoTo getStringErrorManager
   
        numItems = UBound(mdMMVariables.delItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.delItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                
                ret = ret + "<row>"
                ret = ret + "<identifier>" + mdMMVariables.delItems(I) + "</identifier>"
                ret = ret + "</row>"
                
            Next
            ret = ret + END_ROOT
        End If
    
    logToDebug ret
    getStringDelItemsInFolder = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
    
End Function



'from server to outlook
Function updateItem(ByVal xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim I As Integer
Dim J As Integer
Dim Count As Integer

Dim identifier As String
Dim rowBlock As String
Dim xmlMapping As String
xmlMapping = ""
Dim props() As Variant
Dim K As Integer
Dim found As Boolean
       
Dim myOlApp As Outlook.Application
Dim myApptItem As Outlook.AppointmentItem
Dim myContactItem As Outlook.ContactItem
Dim myTaskItem As Outlook.TaskItem
Dim myNoteItem As Outlook.NoteItem
Dim myRecurrPAtt As Outlook.RecurrencePattern
Dim createdEntryID  As String
Set myOlApp = New Outlook.Application
       
      
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderCalendar).Items.Count

    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Items.Count
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderTasks).Items.Count

Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Note"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderNotes).Items.Count

End Select

I = 0
position = 1

ret = getElementContent(xml, "MOD", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    For I = 0 To Val(numItem) - 1
                
        rowBlock = getElementContent(ret, "row", position)
        
        identifier = getElementContent(rowBlock, "identifier", 0)
    
        Dim s As String
        For K = 1 To UBound(props)
            If folderType = FOLDER_TYPE_CON Then
                Dim tmp As Variant
                props(K, 0) = mdVariables.contactsProperties(K).Property
                
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                    getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_CAL Then
                
                props(K, 0) = mdVariables.calendarProperties(K).Property
                
                'put right type to every property. If date is empty put nothing
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                    getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_TASK Then
                                                            
                props(K, 0) = mdVariables.tasksProperties(K).Property
                
                'put right type to every property. If date is empty put nothing
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                 getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                If mdVariables.notesProperties(K).Property <> "Subject" Then
                    
                    Dim tmpNote As Variant
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        tmpNote = defaultNoteValues(props(K, 0), getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        props(K, 1) = tmpNote
                        
                        'props(K, 1) = getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0)
                End If
            End If
        
        Next K
        
        
        found = False
        
        If folderType = FOLDER_TYPE_CAL Then
            
            If Count = 0 Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
                xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    Set myApptItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderCalendar).Items(J)
                    If myApptItem.EntryID = identifier Then
                        mdActions.updateItemCalendar identifier, props(), folderType
                        found = True
                    End If
                Next J
                If found = False Then
                    createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
                    xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    countInsertedItems = countInsertedItems + 1
                End If
            End If
        
        ElseIf folderType = FOLDER_TYPE_TASK Then
            
            If Count = 0 Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
                xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    Set myTaskItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderTasks).Items(J)
                    If myTaskItem.EntryID = identifier Then
                        'used also for update task
                        mdActions.updateItemCalendar identifier, props(), folderType
                        found = True
                    End If
                Next J
                If found = False Then
                    createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
                    xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    countInsertedItems = countInsertedItems + 1
                End If
            End If
        
        ElseIf folderType = FOLDER_TYPE_CON Then 'modify for contacts
            If Count = 0 Then
                
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
                xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    Set myContactItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Items(J)
                    If myContactItem.EntryID = identifier Then
                        mdActions.updateItem identifier, props
                        found = True
                    End If
                Next J
                If found = False Then
                    createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
                    xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    countInsertedItems = countInsertedItems + 1
                End If
            End If
         
         ElseIf folderType = FOLDER_TYPE_NOTE Then 'modify for notes
            If Count = 0 Then
                
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
                xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    Set myNoteItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderNotes).Items(J)
                    If myNoteItem.EntryID = identifier Then
                        mdActions.updateItem identifier, props
                        found = True
                    End If
                Next J
                If found = False Then
                    createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
                    xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    countInsertedItems = countInsertedItems + 1
                End If
            End If
            
        End If
        
    Next
   

End If

updateItem = xmlMapping

End Function
'from server to outlook
Function addItem(ByRef xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String
Dim el As String
Dim ROOT As String

Dim position As Long
Dim numItem As Integer
Dim numItemValid As Integer
numItemValid = 0

Dim I As Integer
Dim J As Integer

Dim identifier As String
Dim rowBlock As String

Dim props() As Variant
Dim K As Integer
       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    'ROOT = "calendar"
    ROOT = ROOT_CAL_NAME
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    ROOT = "contact"

Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    ROOT = "task"
    
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Note"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    ROOT = "note"
        
End Select


Dim xmlMapping As String
xmlMapping = ""

I = 0
position = 1
numItem = 0

ret = getElementContent(xml, "NEW", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    
    numItem = getElementContent(ret, "numItems", 0)
    'xmlMapping = xmlMapping + "<numItems>" + Str(numItem) + "</numItems>"
    For I = 0 To Val(numItem) - 1
        
        Dim createdEntryID As String
        
        rowBlock = getElementContent(ret, "row", position)
                
        identifier = getElementContent(rowBlock, "identifier", 0)
        el = getElementContent(rowBlock, ROOT, 0)
        
        If el <> Empty Then
            numItemValid = numItemValid + 1
            
            If folderType = FOLDER_TYPE_CON Then
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            ElseIf folderType = FOLDER_TYPE_CAL Or folderType = FOLDER_TYPE_TASK Then
                props(0, 0) = "Class"
                props(0, 1) = 26
            End If
                   
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    Dim tmp As Variant
                    
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                    props(K, 1) = tmp
                    
                ElseIf folderType = FOLDER_TYPE_CAL Then
                        
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        
                        'put right type to every property. If date is empty put nothing
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                         getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                        props(K, 1) = tmp
                        
                ElseIf folderType = FOLDER_TYPE_TASK Then
                        
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        'put right type to every property. If date is empty put nothing
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                         getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                        props(K, 1) = tmp
                
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    If mdVariables.notesProperties(K).Property <> "Subject" Then
                        
                        Dim tmpNote As Variant
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        tmpNote = defaultNoteValues(props(K, 0), getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        props(K, 1) = tmpNote
                        
                        'props(K, 1) = getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0)
                    End If
                
                End If
                
            Next K
                          
            
            If folderType = FOLDER_TYPE_CON Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            ElseIf folderType = FOLDER_TYPE_CAL Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
            ElseIf folderType = FOLDER_TYPE_TASK Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
            End If
            
            'Create mapping for return data to dll
            xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
            xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
        Else
        
            printLog "Wrong format. Element dropped: " & rowBlock, INFO_LEVEL
            droppedItems = droppedItems + 1
        End If
        
    Next
    
    numItemValid = numItemValid + countInsertedItems
    
    xmlMapping = "<numItems>" + Str(numItemValid) + "</numItems>" + xmlMapping
    
    logToDebug xmlMapping
End If

'if there are no numItemValid but only item inserted by update...

If numItemValid = 0 And countInsertedItems <> 0 Then

    xmlMapping = "<numItems>" + Str(countInsertedItems) + "</numItems>"

End If

addItem = xmlMapping

End Function
'from server to outlook

Function deleteItem(ByRef xml As String)

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim I As Integer
Dim identifier As String
Dim rowBlock As String

I = 0

position = 1

ret = getElementContent(xml, "DEL", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    For I = 0 To Val(numItem) - 1
       
        rowBlock = getElementContent(ret, "row", position)

        identifier = getElementContent(rowBlock, "identifier", 0)
                
        mdActions.removeItem identifier
        
    Next

End If

deleteItem = "ok"

End Function

Function defaultNoteValues(ByVal name As String, ByVal value As String)
'<Color>3</Color><Height>166</Height><Width>200</Width><Left>110</Left><Top>110</Top>
Dim intValue As String
intValue = value

If name = "Color" Then
    If value = "" Or value = Empty Then
        intValue = 3
    End If

ElseIf name = "Height" Then
    If value = "" Or value = Empty Then
        intValue = 166
    End If
    
ElseIf name = "Width" Then
    If value = "" Or value = Empty Then
        intValue = 200
    End If
    
ElseIf name = "Left" Then
    If value = "" Or value = Empty Then
        intValue = 110
    End If
    
ElseIf name = "Top" Then
    If value = "" Or value = Empty Then
        intValue = 110
    End If
    
End If
defaultNoteValues = intValue

End Function



Function returnElementDataTypeCorrect(ByVal name As String, ByVal value As String)

    If name = "AllDayEvent" Or name = "IsRecurring" Or name = "ReminderSet" Or name = "NoEndDate" Then
        Dim tmpbool As Boolean
        If value = "True" Then
            tmpbool = True
        Else
            tmpbool = False
        End If
        returnElementDataTypeCorrect = tmpbool
        Exit Function
    
    ElseIf name = "BusyStatus" Then
        If value = "" Then
            returnElementDataTypeCorrect = Val("2") 'busy default value
        Else
            returnElementDataTypeCorrect = Val(value)
        End If
        Exit Function
    
    ElseIf name = "RecurrenceType" Or name = "Importance" Or name = "MeetingStatus" _
        Or name = "ReminderMinutesBeforeStart" Or name = "Interval" Or name = "MonthOfYear" _
        Or name = "DayOfMonth" Or name = "DayOfWeekMask" Or name = "Instance" Or name = "ReplyTime" _
        Or name = "Sensitivity" Or name = "Duration" Then
        
        If value = "" Then
            returnElementDataTypeCorrect = Val("0")
        Else
            returnElementDataTypeCorrect = Val(value)
        End If
        Exit Function
    
    ElseIf name = "Start" Or name = "End" Or name = "PatternStartDate" _
        Or name = "PatternEndDate" _
        Or name = "DateCompleted" Or name = "DueDate" Or name = "StartDate" _
        Or name = "Birthday" Or name = "Anniversary" Then
        If value = "" Then
            returnElementDataTypeCorrect = Empty
        Else
            If IsDate(mdMMTimeUtils.dateToCanonical(value)) Then
                If InStr(value, "Z") <> 0 Then
                    returnElementDataTypeCorrect = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(value)))
                Else
                    returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonical(value))
                End If
            Else
            
            End If
        End If
        Exit Function
    End If
    
    returnElementDataTypeCorrect = value
End Function

Public Function isChanged(ByRef folderInfoArray() As FolderInfo)
     
    Dim I As Integer
     
    For I = 1 To UBound(folderInfoArray)
        If folderInfoArray(I).Changed Then 'if changed = True create the folder
            isChanged = "True"
            Exit Function
        Else
            isChanged = "False"
            Exit Function
        End If
    Next I
    
End Function


Public Sub consolidatePreferences(ByRef folderInfoArray() As FolderInfo)
     
    Dim I As Integer
     
    For I = 1 To UBound(folderInfoArray)
        folderInfoArray(I).Changed = False
    Next I
    
End Sub



Function getElementContent(ByRef xml As String, ByVal tag As String, ByRef position)
    'position passato per riferimento. prima di uscire, settato al valore in cui finisce il tag.
    
    Dim openTag As String
    Dim closeTag As String
    Dim startInt As Long
    Dim endInt As Long
    Dim containsShortCloseTag As Integer
    Dim pos As Long
    Dim shortCloseTag As String
    Dim I As Integer
    Dim found As Boolean
    found = False
    
    Dim tmpl As String
    tmpl = ""
    Dim tmpr As String
    tmpr = ""
    
    If (position = Null Or position = 0) Then
        pos = 1
    Else
        pos = position
    End If
    
    
    Dim res As String
    
    openTag = "<" + tag + ">"
    closeTag = "</" + tag + ">"
    shortCloseTag = "<" + tag + "/>"
        
        
    startInt = InStr(pos, xml, openTag)
    
    
    If startInt = 0 Then   'There isn't tag
    
        containsShortCloseTag = InStr(pos, xml, shortCloseTag)
        If containsShortCloseTag <> 0 Then
            getElementContent = Empty ' "" 'If tag <tag/> return ""
            Exit Function
        Else
            openTag = "<" + tag
            startInt = InStr(pos, xml, openTag)
            
            If startInt = 0 Then
                getElementContent = Empty
                Exit Function
            End If
            
            startInt = startInt + Len(openTag)
            For I = 0 To Len(xml)
                If found = False Then
                    startInt = startInt + 1
                    tmpl = Left(xml, startInt)
                    tmpr = Right(tmpl, 1)
                    If tmpr = ">" Then
                        startInt = startInt + 1
                        found = True
                    End If
                End If
            Next I
                        
            'getElementContent = Empty ' "" 'If there is return "". in the future I could like to change values...
            'Exit Function
        End If
        
        
    Else
        startInt = startInt + Len(openTag)
        found = True
    End If
    
    If found = False Then
        getElementContent = Empty ' "" 'If there is return "". in the future I could like to change values...
        Exit Function
    Else
        endInt = InStr(pos, xml, closeTag)
        If endInt = 0 Then
            getElementContent = "-1" 'Error xml not well formed
            Exit Function
        Else
            'nothing to do. All right
        End If
       
    End If
    
    
    Dim initContent As Long
    
    initContent = startInt
    
    res = Mid(xml, initContent, endInt - initContent)
    
    If position <> 0 Then
        position = endInt + Len(closeTag)
    End If
    
    If res = "" Then
        getElementContent = Empty
    Else
        getElementContent = res
    End If

End Function



' ****************************************************************
' This function checks if a process is running on a (remote)
'computer
' Requires WMI
' *****************************************************************
' Check out http://www.activxperts.com for more samples and components
' ****************************************************************************

Function IsOutlookProcessRunning()
    Dim Process, strObject
    Dim proce As String
    proce = "OUTLOOK.EXE"
    IsOutlookProcessRunning = False
    strObject = "winmgmts://localhost"
    For Each Process In GetObject(strObject).InstancesOf("win32_process")
    If UCase(Process.name) = UCase(proce) Then
            IsOutlookProcessRunning = True
            Exit Function
        End If
    Next
End Function


Function ReplaceAll(SourceString As String, ReplaceThis As String, WithThis As String)
    Dim Temp As Variant
    Temp = Split(SourceString, ReplaceThis)
    ReplaceAll = Join(Temp, WithThis)
End Function

